/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of Skein.xs. Do not edit this file, edit Skein.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Skein.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "Optimized_64bit/SHA3api_ref.h"
#include "Optimized_64bit/skein.h"

typedef Skein_256_Ctxt_t  * Digest__Skein__256;
typedef Skein_512_Ctxt_t  * Digest__Skein__512;
typedef Skein1024_Ctxt_t  * Digest__Skein__1024;

#line 24 "Skein.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 76 "Skein.c"

XS(XS_Digest__Skein_Skein); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_Skein)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "hashbitlen, data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	hashbitlen = (int)SvIV(ST(0));
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(1));
	char *	RETVAL;
	dXSTARG;
#line 23 "Skein.xs"
		if (hashbitlen < 0)
			croak("hashbitlen < 0");
	{
		BitSequence     hashval[128];
		char ret[256 + 1];
		int i;
		if ( Hash( hashbitlen, data, (DataLength) SvCUR(ST(1)) * 8, hashval ) != SUCCESS )
			croak("Hash() failed");
		for (i=0; i<hashbitlen/8; i++)
			sprintf(&ret[2*i], "%02X", hashval[i]);
		ST(0) = sv_2mortal(newSVpv(ret, hashbitlen/4));
		XSRETURN(1);
	}
#line 109 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein_skein_256); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_skein_256)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 41 "Skein.xs"
	{
		BitSequence hashval[256/8];
		if ( Hash( 256, data, (DataLength) SvCUR(ST(0)) * 8, hashval ) != SUCCESS )
			croak("Hash(256) failed");
		ST(0) = sv_2mortal(newSVpv(hashval, 256/8));
		XSRETURN(1);
	}
#line 140 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein_skein_512); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_skein_512)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 53 "Skein.xs"
	{
		char hashval[512/8];
		if ( Hash( 512, data, (DataLength) SvCUR(ST(0)) * 8, hashval ) != SUCCESS )
			croak("Hash(512) failed");
		ST(0) = sv_2mortal(newSVpv(hashval, 512/8));
		XSRETURN(1);
	}
#line 171 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein_skein_1024); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_skein_1024)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 65 "Skein.xs"
	{
		char hashval[1024/8];
		if ( Hash( 1024, data, (DataLength) SvCUR(ST(0)) * 8, hashval ) != SUCCESS )
			croak("Hash(1024) failed");
		ST(0) = sv_2mortal(newSVpv(hashval, 1024/8));
		XSRETURN(1);
	}
#line 202 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__256_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__256	ctx;
#line 80 "Skein.xs"
		Skein_256_Ctxt_t *dest;
#line 223 "Skein.c"
	Digest__Skein__256	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::clone",
			"ctx", "Digest::Skein::256");
#line 82 "Skein.xs"
		Newx(dest, 1, Skein_256_Ctxt_t);
		memcpy(dest, ctx, sizeof(*dest));
		RETVAL = dest;
#line 238 "Skein.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::Skein::256", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__256_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "package, hashbitlen=256");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	package = ST(0);
	int	hashbitlen;
	Digest__Skein__256	RETVAL;

	if (items < 2)
	    hashbitlen = 256;
	else {
	    hashbitlen = (int)SvIV(ST(1));
	}
#line 93 "Skein.xs"
		if (hashbitlen > 256)
			croak("hashbitlen > 256");
		if (SvROK(package)) {	/* called as $digest->new or $digest->reset */
			IV tmp;
			Digest__Skein__256	ctx;
			if (! sv_derived_from(package, "Digest::Skein::256"))
				croak("meh.");
			tmp = SvIV((SV*)SvRV(package));
			ctx = INT2PTR(Digest__Skein__256, tmp);
			if ( Skein_256_Init( ctx, items==2 ? hashbitlen : ctx->h.hashBitLen ) != SUCCESS )
				croak("Init() failed");
			RETVAL = ctx;
		}
		else {
			Skein_256_Ctxt_t *ctx;
			Newx(ctx, 1, Skein_256_Ctxt_t);
			if ( Skein_256_Init(ctx, hashbitlen) != SUCCESS )
				croak("Init() failed");
			ST(0) = sv_newmortal();
			sv_setref_pv(ST(0), "Digest::Skein::256", (void*)ctx);
		}
		XSRETURN(1);
#line 291 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__256_hashbitlen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_hashbitlen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__256	ctx;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::hashbitlen",
			"ctx", "Digest::Skein::256");
#line 120 "Skein.xs"
		RETVAL = ctx->h.hashBitLen;
#line 323 "Skein.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__256_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__256	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Digest::Skein::256::DESTROY",
			"ctx");
#line 128 "Skein.xs"
		Safefree(ctx);
#line 353 "Skein.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__Skein__256_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "ctx, data, ...");
    {
	Digest__Skein__256	ctx;
	const u08b_t *	data;
	Digest__Skein__256	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::add",
			"ctx", "Digest::Skein::256");
#line 135 "Skein.xs"
	{
		int i;
		for (i=1; i<items; i++)
			if ( Skein_256_Update(ctx, (const u08b_t *)SvPV_nolen(ST(i)), SvCUR(ST(i))) != SUCCESS )
				croak("Update() failed");
		RETVAL = ctx;
	}
#line 390 "Skein.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__256_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__Skein__256	ctx;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::digest",
			"ctx", "Digest::Skein::256");
#line 147 "Skein.xs"
	{
		char hashval[256/8];
		int len = (ctx->h.hashBitLen + 7) >> 3;
		if ( Skein_256_Final(ctx, hashval) != SUCCESS )
			croak("final() failed");
		if ( Skein_256_Init(ctx, ctx->h.hashBitLen) != SUCCESS ) /* reset */
			croak("Init() failed");
		ST(0) = sv_2mortal(newSVpv(hashval, len));
		XSRETURN(1);
	}
#line 432 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__512_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__512	ctx;
#line 168 "Skein.xs"
		Skein_512_Ctxt_t *dest;
#line 453 "Skein.c"
	Digest__Skein__512	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::clone",
			"ctx", "Digest::Skein::512");
#line 170 "Skein.xs"
		Newx(dest, 1, Skein_512_Ctxt_t);
		memcpy(dest, ctx, sizeof(*dest));
		RETVAL = dest;
#line 468 "Skein.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::Skein::512", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__512_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "package, hashbitlen=512");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	package = ST(0);
	int	hashbitlen;
	Digest__Skein__512	RETVAL;

	if (items < 2)
	    hashbitlen = 512;
	else {
	    hashbitlen = (int)SvIV(ST(1));
	}
#line 181 "Skein.xs"
		if (hashbitlen > 512)
			croak("hashbitlen > 512");
		if (SvROK(package)) {	/* called as $digest->new or $digest->reset */
			IV tmp;
			Digest__Skein__512	ctx;
			if (! sv_derived_from(package, "Digest::Skein::512"))
				croak("meh.");
			tmp = SvIV((SV*)SvRV(package));
			ctx = INT2PTR(Digest__Skein__512, tmp);
			if ( Skein_512_Init( ctx, items==2 ? hashbitlen : ctx->h.hashBitLen ) != SUCCESS )
				croak("Init() failed");
			RETVAL = ctx;
		}
		else {
			Skein_512_Ctxt_t *ctx;
			Newx(ctx, 1, Skein_512_Ctxt_t);
			if ( Skein_512_Init(ctx, hashbitlen) != SUCCESS )
				croak("Init() failed");
			ST(0) = sv_newmortal();
			sv_setref_pv(ST(0), "Digest::Skein::512", (void*)ctx);
		}
		XSRETURN(1);
#line 521 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__512_hashbitlen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_hashbitlen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__512	ctx;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::hashbitlen",
			"ctx", "Digest::Skein::512");
#line 208 "Skein.xs"
		RETVAL = ctx->h.hashBitLen;
#line 553 "Skein.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__512_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__512	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Digest::Skein::512::DESTROY",
			"ctx");
#line 216 "Skein.xs"
		Safefree(ctx);
#line 583 "Skein.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__Skein__512_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "ctx, data, ...");
    {
	Digest__Skein__512	ctx;
	const u08b_t *	data;
	Digest__Skein__512	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::add",
			"ctx", "Digest::Skein::512");
#line 223 "Skein.xs"
	{
		int i;
		for (i=1; i<items; i++)
			if ( Skein_512_Update(ctx, (const u08b_t *)SvPV_nolen(ST(i)), SvCUR(ST(i))) != SUCCESS )
				croak("Update() failed");
		RETVAL = ctx;
	}
#line 620 "Skein.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__512_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__Skein__512	ctx;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::digest",
			"ctx", "Digest::Skein::512");
#line 235 "Skein.xs"
	{
		char hashval[512/8];
		int len = (ctx->h.hashBitLen + 7) >> 3;
		if ( Skein_512_Final(ctx, hashval) != SUCCESS )
			croak("final() failed");
		if ( Skein_512_Init(ctx, ctx->h.hashBitLen) != SUCCESS ) /* reset */
			croak("Init() failed");
		ST(0) = sv_2mortal(newSVpv(hashval, len));
		XSRETURN(1);
	}
#line 662 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__1024_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__1024	ctx;
#line 254 "Skein.xs"
		Skein1024_Ctxt_t *dest;
#line 683 "Skein.c"
	Digest__Skein__1024	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::clone",
			"ctx", "Digest::Skein::1024");
#line 256 "Skein.xs"
		Newx(dest, 1, Skein1024_Ctxt_t);
		memcpy(dest, ctx, sizeof(*dest));
		RETVAL = dest;
#line 698 "Skein.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::Skein::1024", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__1024_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "package, hashbitlen=1024");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	package = ST(0);
	int	hashbitlen;
	Digest__Skein__1024	RETVAL;

	if (items < 2)
	    hashbitlen = 1024;
	else {
	    hashbitlen = (int)SvIV(ST(1));
	}
#line 267 "Skein.xs"
		if (hashbitlen > 1024)
			croak("hashbitlen > 1024");
		if (SvROK(package)) {	/* called as $digest->new or $digest->reset */
			IV tmp;
			Digest__Skein__1024	ctx;
			if (! sv_derived_from(package, "Digest::Skein::1024"))
				croak("meh.");
			tmp = SvIV((SV*)SvRV(package));
			ctx = INT2PTR(Digest__Skein__1024, tmp);
			if ( Skein1024_Init( ctx, items==2 ? hashbitlen : ctx->h.hashBitLen ) != SUCCESS )
				croak("Init() failed");
			RETVAL = ctx;
		}
		else {
			Skein1024_Ctxt_t *ctx;
			Newx(ctx, 1, Skein1024_Ctxt_t);
			if ( Skein1024_Init(ctx, hashbitlen) != SUCCESS )
				croak("Init() failed");
			ST(0) = sv_newmortal();
			sv_setref_pv(ST(0), "Digest::Skein::1024", (void*)ctx);
		}
		XSRETURN(1);
#line 751 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__1024_hashbitlen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_hashbitlen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__1024	ctx;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::hashbitlen",
			"ctx", "Digest::Skein::1024");
#line 294 "Skein.xs"
		RETVAL = ctx->h.hashBitLen;
#line 783 "Skein.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__1024_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	Digest__Skein__1024	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Digest::Skein::1024::DESTROY",
			"ctx");
#line 302 "Skein.xs"
		Safefree(ctx);
#line 813 "Skein.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__Skein__1024_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "ctx, data, ...");
    {
	Digest__Skein__1024	ctx;
	const u08b_t *	data;
	Digest__Skein__1024	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::add",
			"ctx", "Digest::Skein::1024");
#line 309 "Skein.xs"
	{
		int i;
		for (i=1; i<items; i++)
			if ( Skein1024_Update(ctx, (const u08b_t *)SvPV_nolen(ST(i)), SvCUR(ST(i))) != SUCCESS )
				croak("Update() failed");
		RETVAL = ctx;
	}
#line 850 "Skein.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__1024_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__Skein__1024	ctx;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::digest",
			"ctx", "Digest::Skein::1024");
#line 321 "Skein.xs"
	{
		char hashval[1024/8];
		int len = (ctx->h.hashBitLen + 7) >> 3;
		if ( Skein1024_Final(ctx, hashval) != SUCCESS )
			croak("final() failed");
		if ( Skein1024_Init(ctx, ctx->h.hashBitLen) != SUCCESS ) /* reset */
			croak("Init() failed");
		ST(0) = sv_2mortal(newSVpv(hashval, len));
		XSRETURN(1);
	}
#line 892 "Skein.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Digest__Skein); /* prototype to pass -Wmissing-prototypes */
XS(boot_Digest__Skein)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Digest::Skein::Skein", XS_Digest__Skein_Skein, file, "$$");
        (void)newXSproto_portable("Digest::Skein::skein_256", XS_Digest__Skein_skein_256, file, "$");
        (void)newXSproto_portable("Digest::Skein::skein_512", XS_Digest__Skein_skein_512, file, "$");
        (void)newXSproto_portable("Digest::Skein::skein_1024", XS_Digest__Skein_skein_1024, file, "$");
        (void)newXSproto_portable("Digest::Skein::256::clone", XS_Digest__Skein__256_clone, file, "$");
        (void)newXSproto_portable("Digest::Skein::256::new", XS_Digest__Skein__256_new, file, "$;$");
        (void)newXSproto_portable("Digest::Skein::256::hashbitlen", XS_Digest__Skein__256_hashbitlen, file, "$");
        (void)newXSproto_portable("Digest::Skein::256::DESTROY", XS_Digest__Skein__256_DESTROY, file, "$");
        (void)newXSproto_portable("Digest::Skein::256::add", XS_Digest__Skein__256_add, file, "$$;@");
        (void)newXSproto_portable("Digest::Skein::256::digest", XS_Digest__Skein__256_digest, file, "$");
        (void)newXSproto_portable("Digest::Skein::512::clone", XS_Digest__Skein__512_clone, file, "$");
        (void)newXSproto_portable("Digest::Skein::512::new", XS_Digest__Skein__512_new, file, "$;$");
        (void)newXSproto_portable("Digest::Skein::512::hashbitlen", XS_Digest__Skein__512_hashbitlen, file, "$");
        (void)newXSproto_portable("Digest::Skein::512::DESTROY", XS_Digest__Skein__512_DESTROY, file, "$");
        (void)newXSproto_portable("Digest::Skein::512::add", XS_Digest__Skein__512_add, file, "$$;@");
        (void)newXSproto_portable("Digest::Skein::512::digest", XS_Digest__Skein__512_digest, file, "$");
        (void)newXSproto_portable("Digest::Skein::1024::clone", XS_Digest__Skein__1024_clone, file, "$");
        (void)newXSproto_portable("Digest::Skein::1024::new", XS_Digest__Skein__1024_new, file, "$;$");
        (void)newXSproto_portable("Digest::Skein::1024::hashbitlen", XS_Digest__Skein__1024_hashbitlen, file, "$");
        (void)newXSproto_portable("Digest::Skein::1024::DESTROY", XS_Digest__Skein__1024_DESTROY, file, "$");
        (void)newXSproto_portable("Digest::Skein::1024::add", XS_Digest__Skein__1024_add, file, "$$;@");
        (void)newXSproto_portable("Digest::Skein::1024::digest", XS_Digest__Skein__1024_digest, file, "$");
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

